#include "JumpHouse.h"

JumpHouse::JumpHouse()
{
	left_init = 0;
	right_init = 0;

	left_heading = 0;
	right_heading = 0;

	for (int i = 1; i < 3; i++)
	{
		for (int k = 0; k < 3; k++)
		{
			left_acc_buff[i ][k] = 0;
			right_acc_buff[i ][k] = 0;
		}
	}


}

bool JumpHouse::unzuptValid(int* max_acc, int* min_acc)
{
	if ((max_acc[0] - min_acc[0] > 2048 || max_acc[1] - min_acc[1] > 2048 || max_acc[2] - min_acc[2] > 2048) && max_acc[0] > 3000)
	{
		std::cout << "JumpHouse::unzuptValid, " << max_acc[0] << ", " << min_acc[0] << ", " << max_acc[1] << ", "
			<< min_acc[1] << ", " << max_acc[2] << ", " << min_acc[2] << ", " <<endl;

		return true;
	}

	return false;
}


void JumpHouse::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	//̽Ϊڵ
	// 	   
	if (left_zupt == 1 && left_att[1] * 0.0001f > 0.6f)
	{
		std::cout << "if (left_zupt == 1 && left_att[1] * 0.0001f > 0.6f) " << left_att[1] * 0.0001f <<  endl;
		left_zupt = 0;
	}
	if (right_zupt == 1 && right_att[1] * 0.0001f > 0.6f)
	{
		std::cout << "if (right_zupt == 1 && right_att[1] * 0.0001f > 0.6f) " << right_att[1] * 0.0001f << endl;
		right_zupt = 0;
	}

	//һڵĿ
	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	//ݣȫλ
	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_heading, 0, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_heading, 0, LEFT_FOOT);

	//ͨٶȡԼvectorѾ˿еλжʱʱʱжϵЧʱΪ˵ȺʵRSSI
	if (left_step_data_vector.size() > 4 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1)
	{
		//if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left) && press_valid)
		if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
		{
			left_cmd_wait_time = time_stamp;

			left_init = 1;

		}

	}

	if (right_step_data_vector.size() > 4 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1)
	{
		//if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right) && press_valid)
		if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
		{

			right_cmd_wait_time = time_stamp;

			right_init = 1;

		}

	}

	//std::cout << left_acc[0] << ", " << left_acc[1] << ", " << left_acc[2] << std::endl;
	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);

	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
	

	//
	memset(result, -1, 4 * sizeof(int));

	//ж˫Ŵصʱ, rssi < 23 λȻҲû취
	//rssiӳйõ
	static int count;
	count++;
	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 9 && time_stamp - left_cmd_wait_time < 30)
	{
		if (right_init == 1)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << rssi <<  ", "<< count <<  std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN "<< rssi << ", " << count << std::endl;
			}

		}
		else
		{
			result[0] = MOTION_LEFT_ON_FLOOR;
			std::cout << " MOTION_LEFT_ON_FLOOR "  <<time_stamp << ", " << count << std::endl;
		
		}

		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;


	}
	else if (right_init == 1 && time_stamp - right_cmd_wait_time >= 9 && time_stamp - right_cmd_wait_time < 30)
	{
		if (left_init == 1)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE "  << " "<< rssi << ", " << count << std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN "  << " " << rssi << ", " << count << std::endl;
			}

			left_init = 0;

			left_cmd_wait_time = 0;
		}
		else
		{
			result[0] = MOTION_RIGHT_ON_FLOOR;
			std::cout << " MOTION_RIGHT_ON_FLOOR "  << time_stamp << ", " << count << std::endl;
			
		}
		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;

	}

	if (right_init == 1 && time_stamp - right_cmd_wait_time >= 30)
	{
		right_init = 0;
		right_cmd_wait_time = 0;
	}

	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 30)
	{
		left_init = 0;
		left_cmd_wait_time = 0;
	}


	if (result[0] != -1)
	{
		addMotionCount(JUMP_COUNT);
	}

}