#pragma once
#ifndef _pub_h__
#define _pub_h__

#include <iostream>
#include <math.h>
#include <stdlib.h>
#include <vector>
#include <string> 

using namespace std;

#define LEFT_FOOT 1
#define RIGHT_FOOT 2

//#define DANCING_THRESH 5
#define DANCING_THRESH 0
#define CIRCLE_CENTER 22

#define ORIGINTRAJ 0
#define RUNGAME 1
#define DANCEGAME 2
#define H5GAME 8
#define MONSTER 4
#define RUINS 5
#define CYCLE 6
#define BIGFOOT 7

#define TESTGAME 100

#define RSSI_LIMIT

#define PI 3.141592653

#define DANCEGAME_MIN_RSSI 26

#define PRESS_MIN 41000

#define GAME_VERSION "0.3.66"

enum CMD_MOTION
{
    MOTION_STOP = 0,
    MOTION_RUN, // 
    MOTION_JUMP, // 
    MOTION_DOWN, // 
    MOTION_LEFT, // 
    MOTION_RIGHT, // 
    MOTION_FRONT, // ǰ
    MOTION_BACK, // 
    MOTION_LEFT_UP, // -
    MOTION_LEFT_DOWN, // -
    MOTION_RIGHT_UP, // -
    MOTION_RIGHT_DOWN, // -
    MOTION_STEP, // -ԭز
    MOTION_JUMP_OC, // 
    MOTION_JUMP_VERTICAL, // ֱ

    NUMBERS_OF_MOTION,

    MOTION_CANCEL = 0x0100,
};

enum CMD_INTERATION
{
   NONE_INTERATION = 0,
   FRONT_LEFT,//ϼ
   FRONT_RIGHT,//ϼ
   BACK_LEFT,//¼
   BACK_RIGHT,//¼

   ENTER_KEY,//ȷϼ
   CANCLE_KEY,//ȡ
};

struct posData
{
	float pos_x;
	float pos_y;
	float rssi;
};

struct FootActionState {

    int FootState;

    int StateCount;

    uint32_t Triggering_time;
};

#endif