#include "JumpHouse.h"

JumpHouse::JumpHouse()
{
	left_init = 0;
	right_init = 0;

	left_heading = 0;
	right_heading = 0;

	for (int i = 1; i < 3; i++)
	{
		for (int k = 0; k < 3; k++)
		{
			left_acc_buff[i ][k] = 0;
			right_acc_buff[i ][k] = 0;
		}
	}

	left_back_press_offset = 40000;

	right_back_press_offset = 40000;

	left_back_press_detect_time = 50;


    right_back_press_detect_time = 50;

}

bool JumpHouse::unzuptValid(int* max_acc, int* min_acc)
{
	if ((max_acc[0] - min_acc[0] > 2048 || max_acc[1] - min_acc[1] > 2048 || max_acc[2] - min_acc[2] > 2048) && max_acc[2] > 3000)
	{
		std::cout << "JumpHouse::unzuptValid" << endl;
		return true;
	}

	return false;
}


void JumpHouse::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{
	//һڵĿ
	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	//ݣȫλ
	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_heading, 0, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_heading, 0, LEFT_FOOT);

	//Ÿص

	left_back_press_vector.push_back(left_back_press);

	if(left_back_press_vector.size()> 10)
	{
		//ʾдʱ򣬴, ǲΪٴ
		left_back_press_vector.pop_front();
		auto max_point = std::max_element(left_back_press_vector.begin(), left_back_press_vector.end());
		auto min_point = std::min_element(left_back_press_vector.begin(), left_back_press_vector.end());

		if (left_back_press > *min_point + 2000 && max_point > min_point)
		{
			int offser_temp = *min_point;

			if (left_back_press_detect_time == 0)
			{
				left_back_press_detect_time = 50;
			}


			if (offser_temp < left_back_press_offset + 10)
			{
				left_back_press_detect_time = 50;
				left_back_press_offset = offser_temp;
			}
		}
		if (left_back_press_detect_time > 0)
		{
			if (left_back_press < left_back_press_offset + 2000)
			{
				left_back_press_detect_time = 0;

				left_back_press_offset = 40000;
			}
		}
	}


	right_back_press_vector.push_back(right_back_press);

	if (right_back_press_vector.size() > 10)
	{
		//ʾдʱ򣬴, ǲΪٴ
		right_back_press_vector.pop_front();
		auto max_point = std::max_element(right_back_press_vector.begin(), right_back_press_vector.end());
		auto min_point = std::min_element(right_back_press_vector.begin(), right_back_press_vector.end());

		if (right_back_press > *min_point + 2000 && max_point > min_point)
		{
			int offser_temp = *min_point;

			if (right_back_press_detect_time == 0)
			{
				right_back_press_detect_time = 50; 		
				right_back_press_offset = offser_temp;
			}


			if (offser_temp < right_back_press_offset + 10)
			{
				right_back_press_detect_time = 50;
				right_back_press_offset = offser_temp;
			}


		}
		if (right_back_press_detect_time > 0)
		{
			if (  right_back_press < right_back_press_offset + 2000)
			{
				right_back_press_detect_time = 0;

				right_back_press_offset = 40000;

	
			}
		}
	}

	left_front_press_vector.push_back(left_front_press);
	right_front_press_vector.push_back(right_front_press);
	if (left_front_press_vector.size() > 10)
	{
		left_front_press_vector.pop_front(); right_front_press_vector.pop_front();
	}

	if (left_front_press_vector.size() == 10)
	{
		auto front_max_point = max_element(left_front_press_vector.begin(), left_front_press_vector.end());
		auto front_min_point = min_element(left_front_press_vector.begin(), left_front_press_vector.end());

		auto back_max_point = max_element(left_back_press_vector.begin(), left_back_press_vector.end());
		auto back_min_point = min_element(left_back_press_vector.begin(), left_back_press_vector.end());

		if (front_max_point > front_min_point && *front_max_point - *front_min_point > 2000 && *front_max_point - left_front_press < 50)
		{
			left_press_valid = 10;
		}

		if (back_max_point > back_min_point && *back_max_point - *back_min_point > 2000 && *back_max_point - left_back_press < 50)
		{
			left_press_valid = 10;
		}
	}

	if (right_front_press_vector.size() == 10)
	{
		auto front_max_point = max_element(right_front_press_vector.begin(), right_front_press_vector.end());
		auto front_min_point = min_element(right_front_press_vector.begin(), right_front_press_vector.end());

		auto back_max_point = max_element(right_back_press_vector.begin(), right_back_press_vector.end());
		auto back_min_point = min_element(right_back_press_vector.begin(), right_back_press_vector.end());

		if (front_max_point > front_min_point && *front_max_point - *front_min_point > 2000 && *front_max_point - right_front_press < 50)
		{
			right_press_valid = 10;
		}

		if (back_max_point > back_min_point && *back_max_point - *back_min_point > 2000 && *back_max_point - right_back_press < 50)
		{
			right_press_valid = 10;
		}
	}

	//ͨٶȡԼvectorѾ˿еλжʱʱʱжϵЧʱΪ˵ȺʵRSSI
	if (left_step_data_vector.size() > 4 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1
		&& (left_back_press_detect_time == 0 || left_back_press_detect_time == 50))
	{
		
		//if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left) && press_valid)
		if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
		{

			left_cmd_wait_time = time_stamp;

			left_init = 1;

		}

	}

	if (right_step_data_vector.size() > 4 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1
		&& (right_back_press_detect_time == 0 || right_back_press_detect_time == 50))
	{

		//if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right) && press_valid)
		if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
		{

			right_cmd_wait_time = time_stamp;

			right_init = 1;

		}

	}

	/*Ӽٶȹ
	for (int i = 1; i < 3; i++)
	{
		for (int k = 0; k < 3; k++)
		{
			left_acc_buff[i - 1][k] = left_acc_buff[i][k];
			right_acc_buff[i - 1][k] = right_acc_buff[i][k];
		}
	}

	for (int i = 0; i < 3; i++)
	{
		left_acc_buff[2][i] = left_acc[i]; right_acc_buff[2][i] = right_acc[i];
	}

	for (int i = 0; i < 3; i++)
	{
		left_acc[i] = max(max(left_acc_buff[0][i], left_acc_buff[1][i]), left_acc_buff[2][i]);

		right_acc[i] = max(max(right_acc_buff[0][i], right_acc_buff[1][i]), right_acc_buff[2][i]);

		left_acc[i]  = (left_acc_buff[0][i] +  left_acc_buff[1][i]  +  left_acc_buff[2][i]) * 0.3333;

		right_acc[i] = (right_acc_buff[0][i] + right_acc_buff[1][i] + right_acc_buff[2][i]) * 0.3333;

	}*/

	if (left_step_data_vector.size() > 1 && left_zupt == 0)
	{
		setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	}
	else
	{
		for (int k = 0; k < 3; k++)
		{
			max_acc_unzupt_left[k] = left_acc[k]; 
			min_acc_unzupt_left[k] = left_acc[k];
		}
	}

	if (right_step_data_vector.size() > 1 && right_zupt == 0)
	{
		setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
	}
	else
	{
		for (int k = 0; k < 3; k++)
		{
			max_acc_unzupt_right[k] = right_acc[k];
			min_acc_unzupt_right[k] = left_acc[k];
		}
	}

	static int count = 0;

	count++;

	//
	memset(result, -1, 4 * sizeof(int));

	//ж˫Ŵصʱ, rssi < 23 λȻҲû취
	//rssiӳйõ

	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 9 && time_stamp - left_cmd_wait_time < 20 && left_press_valid > 0)
	{
		if (right_init == 1 && right_press_valid > 0)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << count  << " " << rssi << std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN " << count  << " " << rssi << std::endl;
			}

		}
		else
		{
			result[0] = MOTION_LEFT_ON_FLOOR;
			std::cout << " MOTION_LEFT_ON_FLOOR " << count << " "<<time_stamp << std::endl;
		
		}

		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;
		left_press_valid = 0;

		right_press_valid = 0;

	}
	else if (right_init == 1 && time_stamp - right_cmd_wait_time >= 9 && time_stamp - right_cmd_wait_time < 20 && right_press_valid > 0)
	{
		if (left_init == 1 && left_press_valid > 0)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << count << " "<< rssi << std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN " << count << " " << rssi << std::endl;
			}

			left_init = 0;

			left_cmd_wait_time = 0;
		}
		else
		{
			result[0] = MOTION_RIGHT_ON_FLOOR;
			std::cout << " MOTION_RIGHT_ON_FLOOR " << count << std::endl;
			
		}
		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;

		left_press_valid = 0;

		right_press_valid = 0;
	}
	if (right_init == 1 && time_stamp - right_cmd_wait_time >= 20)
	{
		right_init = 0;
		right_cmd_wait_time = 0;
	}

	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 20)
	{
		left_init = 0;
		left_cmd_wait_time = 0;
	}

	//else if (count < 850 && count > 830)
	//{
	//	std::cout << "right_init : " << right_init << " time_stamp - right_cmd_wait_time : " << time_stamp - right_cmd_wait_time
	//		<< " right_press_valid : " << right_press_valid << endl;
	//}

	if (result[0] != -1)
	{
		addMotionCount(JUMP_COUNT);
	}

	if (left_back_press_detect_time > 0) left_back_press_detect_time--;
	if (right_back_press_detect_time > 0) right_back_press_detect_time--;

	if (left_press_valid > 0)
	{
		left_press_valid--;
	}

	if (right_press_valid > 0)
	{
		right_press_valid--;
	}
}