#pragma once
#ifndef __dance_game_h__
#define __dance_game_h__

#include "DanceFoot.h"

class DanceGame {

	public :
		DanceGame();

		//void Process(int* right_pos, int* right_att, int right_zupt, int* left_pos, int* left_att, int left_zupt, int jump, int down, int rssi);
		void Process(int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_press,
			int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_press,
			int jump, int down, int rssi);

		void getResult(int *matrix);

		float getGamePos(int left_or_right, int index);

		int isBalance(float acc_buff[3][15]);

	private:

		DanceFoot leftFoot;
		DanceFoot rightFoot;

		int result[4];

		int left_result;
		int right_result;

		float left_acc_buff[3][15];
		float right_acc_buff[3][15];


};

#endif
