#pragma once
#ifndef _H5_H_
#define _H5_H_

#include "pub.h"

class H5
{
public:
	H5();

	void Process(int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_press,
		int jump, int down, int rssi);

	void getResult(int* dec);

private:
	int resultMatrix[4];

	int last_left_zupt;
	int last_right_zupt;

	int last_jump;
	int last_down;

	int CANCLE_DOWN;
	int CANCLE_JUMP;
	
	int valid_down_wait_time;
	int valid_jump_wait_time;
	
};


#endif