
#include "PublicSDKMotion.h"
#include "pub.h"

class H5 : public PublicSDKMotion
{
public:
	H5();

	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);


private:

	int last_left_zupt;
	int last_right_zupt;

	int last_jump;
	int last_down;

	int CANCLE_DOWN;
	int CANCLE_JUMP;

	int valid_down_wait_time;
	int valid_jump_wait_time;

	deque<int> left_front_press_deque;
	deque<int> right_front_press_deque;

};