
#include "PublicSDKMotion.h"
#include "pub.h"

class Kongfu : public PublicSDKMotion
{
public:
	Kongfu();

	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);

private:

	deque<shoes_data_cell> left_shoes_data_vector;
	deque<shoes_data_cell> right_shoes_data_vector;

	vector<float> left_acc_x_buff;
	vector<float> right_acc_x_buff;

	int left_kick;
	int last_left_kick;
	int left_kick_wait;

	int right_kick;
	int last_right_kick;
	int right_kick_wait;

	int CANCLE_FLOOR_CMD_LEFT;
	int CANCLE_FLOOR_CMD_RIGHT;

	int last_left_zupt;
	int last_right_zupt;

	int last_jump;
	int last_down;

	int CANCLE_DOWN;
	int CANCLE_JUMP;

	int valid_down_wait_time;
	int valid_jump_wait_time;

	int cmd_jump_wait_time;
	
	const int CMD_JUMP_WAIT_TIME = 5;

	const int  WAIT_TIME = 10;

	 deque<int> left_acc_deque;
	 deque<int> right_acc_deque;

	 int wait_down = 0;

};