#pragma once
#ifndef _pub_h__
#define _pub_h__

#include <iostream>
#include <math.h>
#include <stdlib.h>
#include <vector>
#include <string> 
#include <algorithm>

using namespace std;

#define LEFT_FOOT 1
#define RIGHT_FOOT 2

//#define DANCING_THRESH 5
#define DANCING_THRESH 0
#define CIRCLE_CENTER 22

#define ORIGINTRAJ 0
#define RUNGAME 1
#define DANCEGAME 2
#define H5GAME 3
#define MONSTER 4
#define RUINS 5
#define CYCLE 6
#define BIGFOOT 7
#define FINGERGUESSING 8
#define AEROBICS 9
#define KONGFU 10
#define SPORT 11
#define BUILDHOUSE 12
#define CUTCAKE 13
#define JUMPHOUSE 14

#define TESTGAME 100

#define RSSI_LIMIT

#define PI 3.141592653

#define DANCEGAME_MIN_RSSI 26

#define PRESS_MIN 41000

#define GAME_VERSION "0.6.4"

enum CMD_MOTION
{
    MOTION_STOP = 0,
    MOTION_RUN, // 
    MOTION_JUMP, // 
    MOTION_DOWN, // 
    MOTION_LEFT, // 
    MOTION_RIGHT, // 
    MOTION_FRONT, // ǰ
    MOTION_BACK, // 
    MOTION_LEFT_UP, // -
    MOTION_LEFT_DOWN, // -
    MOTION_RIGHT_UP, // -
    MOTION_RIGHT_DOWN, // -
    MOTION_STEP, // -ԭز
    MOTION_JUMP_OC, // 
    MOTION_JUMP_VERTICAL, // ֱ
    MOTION_ROCK, //ʯͷ
    MOTION_SCISSORS, //
    MOTION_PAPER, //

    MOTION_STRETCH_LEFT, //
    MOTION_LIFT_LEFT, //̧

    MOTION_STRETCH_RIGHT, //
    MOTION_LIFT_RIGHT, //̧

    MOTION_STRETCH_FRONT_LEFT,
    MOTION_STRETCH_FRONT_RIGHT,

    MOTION_DOWN_FRONT, //ڽŶ

    MOTION_LEFT_ON_FLOOR,//ȵ
    MOTION_RIGHT_ON_FLOOR, //Ҳȵ

    MOTION_BOTH_ON_FLOOR_CLOSE, //ϽŲȵ
    MOTION_BOTH_ON_FLOOR_OPEN, //Ųȵ

    NUMBERS_OF_MOTION,

    MOTION_CANCEL = 0x0100,
};

enum MOTION_COUNT_TYPE {
    STEP_COUNT = 0,

    JUMP_COUNT,
    
    DOWN_COUNT,

    KICK_COUNT,

    PAPER_COUNT,

    SCISSORS_COUNT,

    ROCK_COUNT,

};

enum CMD_INTERATION
{
   NONE_INTERATION = 0,
   FRONT_LEFT,//ϼ
   FRONT_RIGHT,//ϼ
   BACK_LEFT,//¼
   BACK_RIGHT,//¼
   ENTER_KEY,//ȷϼ
   CANCLE_KEY,//ȡ
};

struct posData
{
	float pos_x;
	float pos_y;
	float rssi;
};

struct FootActionState {

    int FootState;

    int StateCount;

    uint32_t Triggering_time;
};

struct globalPos_struct {
    int time_stamp;

    float pos_x;
    float pos_y;
    float pos_z;
};


#endif