
#include "PublicSDKMotion.h"

#include <deque>

using namespace std;


struct dualAccData {
	int left_acc;
	int right_acc;
};
//Խ
class BuildHouse: public PublicSDKMotion {

	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);

	int back_press_up_trend(deque<int>& left_press_deque, deque<int>& right_press_deque);


	deque<dualAccData> dual_acc;

	deque<int> left_press_filter_window;
	deque<int> right_press_filter_window;

	deque<int> left_front_press_queue;
	deque<int> left_back_press_queue;

	deque<int> right_front_press_queue;
	deque<int> right_back_press_queue;

	int last_down = 0;
	int last_front_down = 0;

	int cmd_wait_time = 0;

	int left_front_press_top = 0;
	int right_front_press_top = 0;

	int wait_press_top_unvalid = 0;

	int left_back_press_top = 0;
	int right_back_press_top = 0;
	
	int wait_back_press_top_unvalid = 0;

	
};